package dmillerw.menu.network.packet.server;

import dmillerw.menu.helper.HeldHelper;
import dmillerw.menu.network.packet.Packet;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.ItemStack;
import net.minecraft.network.PacketBuffer;
import net.minecraft.util.EnumHand;

import java.io.IOException;

/**
 * @author dmillerw
 */
public class PacketUseItem extends Packet<PacketUseItem> {
    private int slot;

    public PacketUseItem() {
    }

    public PacketUseItem(int slot) {
        this.slot = slot;
    }

    @Override
    protected void handleClientSide(EntityPlayer player) {
    }

    @Override
    protected void handleServerSide(EntityPlayer player) {
        ItemStack slotStack = player.field_71071_by.func_70301_a(slot);
        ItemStack held = player.func_184614_ca();
        EnumHand hand = EnumHand.MAIN_HAND;
        EntityEquipmentSlot slot = HeldHelper.getSlotFromHand(hand);

        player.func_184201_a(slot, slotStack);
        ItemStack heldItem = player.func_184586_b(hand);
        if (!heldItem.func_190926_b()) {
            heldItem.func_77957_a(player.field_70170_p, player, hand).func_188398_b();
        }
        player.func_184201_a(slot, held);

        ((EntityPlayerMP) player).func_71120_a(player.field_71069_bz);
    }

    @Override
    public void toBytes(PacketBuffer buffer) {
        buffer.writeInt(slot);
    }

    @Override
    public void fromBytes(PacketBuffer buffer) throws IOException {
        slot = buffer.readInt();
    }
}
