package dmillerw.menu.data.click;

import net.minecraft.client.Minecraft;
import net.minecraft.client.entity.EntityPlayerSP;
import net.minecraft.client.gui.GuiConfirmOpenLink;
import net.minecraft.util.text.TextComponentString;
import net.minecraftforge.client.ClientCommandHandler;

/**
 * @author dmillerw
 */
public class ClickActionCommand implements ClickAction.IClickAction {
    public final String command;
    public boolean clipboard;

    public ClickActionCommand(String command, boolean clipboard) {
        this.command = command;
        this.clipboard = clipboard;
    }

    @Override
    public ClickAction getClickAction() {
        return ClickAction.COMMAND;
    }

    @Override
    public boolean onClicked() {
        EntityPlayerSP player = Minecraft.func_71410_x().field_71439_g;
        String parsedCommand = command.replace("@p", player.func_70005_c_());

        if (ClientCommandHandler.instance.func_71556_a(player, parsedCommand) == 0) {
            if (clipboard) {
                GuiConfirmOpenLink.func_146275_d(parsedCommand);
                player.func_146105_b(new TextComponentString("Command copied to clipboard"), true);
            } else {
                player.func_71165_d(parsedCommand);
            }
        }
        return false;
    }

    @Override
    public void onRemoved() {
        clipboard = !clipboard;
    }
}
