package dmillerw.menu.data.session;

import dmillerw.menu.data.click.ClickAction;
import dmillerw.menu.data.menu.MenuItem;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;

import javax.annotation.Nonnull;

/**
 * @author dmillerw
 */
public class EditSessionData {
    public static String title;
    @Nonnull
    public static ItemStack icon;
    public static ClickAction.IClickAction clickAction;

    public static void clear() {
        title = "";
        icon = new ItemStack(Blocks.field_150348_b);
        clickAction = null;
    }

    public static void fromMenuItem(MenuItem item) {
        title = item != null && item.title != null ? item.title : "";
        icon = item != null && !item.icon.func_190926_b() ? item.icon : new ItemStack(Blocks.field_150348_b);
        clickAction = item != null && item.clickAction != null ? item.clickAction : null;
    }

    public static MenuItem toMenuItem() {
        return new MenuItem(title, icon, clickAction);
    }
}
