package dmillerw.menu.helper;

import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiScreen;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.VertexBuffer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;

/**
 * @author dmillerw
 */
public class GuiRenderHelper {

    public static void renderHeaderAndFooter(GuiScreen base, int headerHeight, int footerHeight, int shadowDepth, String headerText) {
        GlStateManager.func_179094_E();

        GlStateManager.func_179147_l();
        GlStateManager.func_179120_a(770, 771, 0, 1);
        GlStateManager.func_179118_c();
        GlStateManager.func_179103_j(7425);
        GlStateManager.func_179090_x();

        Tessellator tessellator = Tessellator.func_178181_a();
        VertexBuffer vertexbuffer = tessellator.func_178180_c();

        // HEADER - SHADOW
        vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181709_i);

        vertexbuffer.func_181662_b(0, headerHeight + shadowDepth, 0.0D).func_187315_a(0.0D, 1.0D).func_181669_b(0, 0, 0, 0).func_181675_d();
        vertexbuffer.func_181662_b(base.field_146294_l, headerHeight + shadowDepth, 0.0D).func_187315_a(1.0D, 1.0D).func_181669_b(0, 0, 0, 0).func_181675_d();

        vertexbuffer.func_181662_b(base.field_146294_l, headerHeight, 0.0D).func_187315_a(1.0D, 0.0D).func_181669_b(0, 0, 0, 255).func_181675_d();
        vertexbuffer.func_181662_b(0, headerHeight, 0.0D).func_187315_a(0.0D, 0.0D).func_181669_b(0, 0, 0, 255).func_181675_d();

        tessellator.func_78381_a();

        // FOOTER - SHADOW
        vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181709_i);

        vertexbuffer.func_181662_b(0, base.field_146295_m - footerHeight, 0.0D).func_187315_a(0.0D, 1.0D).func_181669_b(0, 0, 0, 255).func_181675_d();
        vertexbuffer.func_181662_b(base.field_146294_l, base.field_146295_m - footerHeight, 0.0D).func_187315_a(1.0D, 1.0D).func_181669_b(0, 0, 0, 255).func_181675_d();

        vertexbuffer.func_181662_b(base.field_146294_l, base.field_146295_m - footerHeight - shadowDepth, 0.0D).func_187315_a(1.0D, 0.0D).func_181669_b(0, 0, 0, 0).func_181675_d();
        vertexbuffer.func_181662_b(0, base.field_146295_m - footerHeight - shadowDepth, 0.0D).func_187315_a(0.0D, 0.0D).func_181669_b(0, 0, 0, 0).func_181675_d();

        tessellator.func_78381_a();

        GlStateManager.func_179098_w();
        GlStateManager.func_179103_j(7424);
        GlStateManager.func_179141_d();
        GlStateManager.func_179084_k();

        GlStateManager.func_179121_F();

        GlStateManager.func_179094_E();

        base.field_146297_k.func_110434_K().func_110577_a(Gui.field_110325_k);

        GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
        float f = 32F;

        // HEADER
        vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181709_i);

        vertexbuffer.func_181662_b((double) 0, (double) headerHeight, 0.0D).func_187315_a(0.0D, (double) ((float) headerHeight / f)).func_181669_b(64, 64, 64, 255).func_181675_d();
        vertexbuffer.func_181662_b((double) 0 + base.field_146294_l, (double) headerHeight, 0.0D).func_187315_a((double) ((float) base.field_146294_l / f), (double) ((float) headerHeight / f)).func_181669_b(64, 64, 64, 255).func_181675_d();

        vertexbuffer.func_181662_b((double) 0 + base.field_146294_l, (double) 0, 0.0D).func_187315_a((double) ((float) base.field_146294_l / f), (double) ((float) 0 / f)).func_181669_b(64, 64, 64, 255).func_181675_d();
        vertexbuffer.func_181662_b((double) 0, (double) 0, 0.0D).func_187315_a(0.0D, (double) ((float) 0 / f)).func_181669_b(64, 64, 64, 255).func_181675_d();

        tessellator.func_78381_a();

        // FOOTER
        vertexbuffer.func_181668_a(7, DefaultVertexFormats.field_181709_i);

        vertexbuffer.func_181662_b((double) 0, (double) base.field_146295_m, 0.0D).func_187315_a(0.0D, (double) ((float) headerHeight / f)).func_181669_b(64, 64, 64, 255).func_181675_d();
        vertexbuffer.func_181662_b((double) 0 + base.field_146294_l, (double) base.field_146295_m, 0.0D).func_187315_a((double) ((float) base.field_146294_l / f), (double) ((float) headerHeight / f)).func_181669_b(64, 64, 64, 255).func_181675_d();

        vertexbuffer.func_181662_b((double) 0 + base.field_146294_l, (double) base.field_146295_m - footerHeight, 0.0D).func_187315_a((double) ((float) base.field_146294_l / f), (double) ((float) 0 / f)).func_181669_b(64, 64, 64, 255).func_181675_d();
        vertexbuffer.func_181662_b((double) 0, (double) base.field_146295_m - footerHeight, 0.0D).func_187315_a(0.0D, (double) ((float) 0 / f)).func_181669_b(64, 64, 64, 255).func_181675_d();

        tessellator.func_78381_a();

        GlStateManager.func_179121_F();

        base.func_73732_a(base.field_146297_k.field_71466_p, headerText, base.field_146294_l / 2, 8, 16777215);
    }
}
